require '_h2ph_pre.ph';

unless(defined(&DC21285_PCI_IACK)) {
    sub DC21285_PCI_IACK () {	0x79000000;}
}
unless(defined(&DC21285_ARMCSR_BASE)) {
    sub DC21285_ARMCSR_BASE () {	0x42000000;}
}
unless(defined(&DC21285_PCI_TYPE_0_CONFIG)) {
    sub DC21285_PCI_TYPE_0_CONFIG () {	0x7b000000;}
}
unless(defined(&DC21285_PCI_TYPE_1_CONFIG)) {
    sub DC21285_PCI_TYPE_1_CONFIG () {	0x7a000000;}
}
unless(defined(&DC21285_OUTBOUND_WRITE_FLUSH)) {
    sub DC21285_OUTBOUND_WRITE_FLUSH () {	0x78000000;}
}
unless(defined(&DC21285_FLASH)) {
    sub DC21285_FLASH () {	0x41000000;}
}
unless(defined(&DC21285_PCI_IO)) {
    sub DC21285_PCI_IO () {	0x7c000000;}
}
unless(defined(&DC21285_PCI_MEM)) {
    sub DC21285_PCI_MEM () {	0x80000000;}
}
unless(defined(&__ASSEMBLY__)) {
    require 'asm/arch/hardware.ph';
    eval 'sub DC21285_IO {
        local($x) = @_;
	    eval q((( &ARMCSR_BASE+($x))));
    }' unless defined(&DC21285_IO);
} else {
    eval 'sub DC21285_IO {
        local($x) = @_;
	    eval q(($x));
    }' unless defined(&DC21285_IO);
}
unless(defined(&CSR_PCICMD)) {
    sub CSR_PCICMD () {	 &DC21285_IO(0x0004);}
}
unless(defined(&CSR_CLASSREV)) {
    sub CSR_CLASSREV () {	 &DC21285_IO(0x0008);}
}
unless(defined(&CSR_PCICACHELINESIZE)) {
    sub CSR_PCICACHELINESIZE () {	 &DC21285_IO(0x000c);}
}
unless(defined(&CSR_PCICSRBASE)) {
    sub CSR_PCICSRBASE () {	 &DC21285_IO(0x0010);}
}
unless(defined(&CSR_PCICSRIOBASE)) {
    sub CSR_PCICSRIOBASE () {	 &DC21285_IO(0x0014);}
}
unless(defined(&CSR_PCISDRAMBASE)) {
    sub CSR_PCISDRAMBASE () {	 &DC21285_IO(0x0018);}
}
unless(defined(&CSR_PCIROMBASE)) {
    sub CSR_PCIROMBASE () {	 &DC21285_IO(0x0030);}
}
unless(defined(&CSR_MBOX0)) {
    sub CSR_MBOX0 () {	 &DC21285_IO(0x0050);}
}
unless(defined(&CSR_MBOX1)) {
    sub CSR_MBOX1 () {	 &DC21285_IO(0x0054);}
}
unless(defined(&CSR_MBOX2)) {
    sub CSR_MBOX2 () {	 &DC21285_IO(0x0058);}
}
unless(defined(&CSR_MBOX3)) {
    sub CSR_MBOX3 () {	 &DC21285_IO(0x005c);}
}
unless(defined(&CSR_DOORBELL)) {
    sub CSR_DOORBELL () {	 &DC21285_IO(0x0060);}
}
unless(defined(&CSR_DOORBELL_SETUP)) {
    sub CSR_DOORBELL_SETUP () {	 &DC21285_IO(0x0064);}
}
unless(defined(&CSR_ROMWRITEREG)) {
    sub CSR_ROMWRITEREG () {	 &DC21285_IO(0x0068);}
}
unless(defined(&CSR_CSRBASEMASK)) {
    sub CSR_CSRBASEMASK () {	 &DC21285_IO(0x00f8);}
}
unless(defined(&CSR_CSRBASEOFFSET)) {
    sub CSR_CSRBASEOFFSET () {	 &DC21285_IO(0x00fc);}
}
unless(defined(&CSR_SDRAMBASEMASK)) {
    sub CSR_SDRAMBASEMASK () {	 &DC21285_IO(0x0100);}
}
unless(defined(&CSR_SDRAMBASEOFFSET)) {
    sub CSR_SDRAMBASEOFFSET () {	 &DC21285_IO(0x0104);}
}
unless(defined(&CSR_ROMBASEMASK)) {
    sub CSR_ROMBASEMASK () {	 &DC21285_IO(0x0108);}
}
unless(defined(&CSR_SDRAMTIMING)) {
    sub CSR_SDRAMTIMING () {	 &DC21285_IO(0x010c);}
}
unless(defined(&CSR_SDRAMADDRSIZE0)) {
    sub CSR_SDRAMADDRSIZE0 () {	 &DC21285_IO(0x0110);}
}
unless(defined(&CSR_SDRAMADDRSIZE1)) {
    sub CSR_SDRAMADDRSIZE1 () {	 &DC21285_IO(0x0114);}
}
unless(defined(&CSR_SDRAMADDRSIZE2)) {
    sub CSR_SDRAMADDRSIZE2 () {	 &DC21285_IO(0x0118);}
}
unless(defined(&CSR_SDRAMADDRSIZE3)) {
    sub CSR_SDRAMADDRSIZE3 () {	 &DC21285_IO(0x011c);}
}
unless(defined(&CSR_I2O_INFREEHEAD)) {
    sub CSR_I2O_INFREEHEAD () {	 &DC21285_IO(0x0120);}
}
unless(defined(&CSR_I2O_INPOSTTAIL)) {
    sub CSR_I2O_INPOSTTAIL () {	 &DC21285_IO(0x0124);}
}
unless(defined(&CSR_I2O_OUTPOSTHEAD)) {
    sub CSR_I2O_OUTPOSTHEAD () {	 &DC21285_IO(0x0128);}
}
unless(defined(&CSR_I2O_OUTFREETAIL)) {
    sub CSR_I2O_OUTFREETAIL () {	 &DC21285_IO(0x012c);}
}
unless(defined(&CSR_I2O_INFREECOUNT)) {
    sub CSR_I2O_INFREECOUNT () {	 &DC21285_IO(0x0130);}
}
unless(defined(&CSR_I2O_OUTPOSTCOUNT)) {
    sub CSR_I2O_OUTPOSTCOUNT () {	 &DC21285_IO(0x0134);}
}
unless(defined(&CSR_I2O_INPOSTCOUNT)) {
    sub CSR_I2O_INPOSTCOUNT () {	 &DC21285_IO(0x0138);}
}
unless(defined(&CSR_SA110_CNTL)) {
    sub CSR_SA110_CNTL () {	 &DC21285_IO(0x013c);}
}
unless(defined(&SA110_CNTL_INITCMPLETE)) {
    sub SA110_CNTL_INITCMPLETE () {	(1<< 0);}
}
unless(defined(&SA110_CNTL_ASSERTSERR)) {
    sub SA110_CNTL_ASSERTSERR () {	(1<< 1);}
}
unless(defined(&SA110_CNTL_RXSERR)) {
    sub SA110_CNTL_RXSERR () {	(1<< 3);}
}
unless(defined(&SA110_CNTL_SA110DRAMPARITY)) {
    sub SA110_CNTL_SA110DRAMPARITY () {	(1<< 4);}
}
unless(defined(&SA110_CNTL_PCISDRAMPARITY)) {
    sub SA110_CNTL_PCISDRAMPARITY () {	(1<< 5);}
}
unless(defined(&SA110_CNTL_DMASDRAMPARITY)) {
    sub SA110_CNTL_DMASDRAMPARITY () {	(1<< 6);}
}
unless(defined(&SA110_CNTL_DISCARDTIMER)) {
    sub SA110_CNTL_DISCARDTIMER () {	(1<< 8);}
}
unless(defined(&SA110_CNTL_PCINRESET)) {
    sub SA110_CNTL_PCINRESET () {	(1<< 9);}
}
unless(defined(&SA110_CNTL_I2O_256)) {
    sub SA110_CNTL_I2O_256 () {	(0<< 10);}
}
unless(defined(&SA110_CNTL_I20_512)) {
    sub SA110_CNTL_I20_512 () {	(1<< 10);}
}
unless(defined(&SA110_CNTL_I2O_1024)) {
    sub SA110_CNTL_I2O_1024 () {	(2<< 10);}
}
unless(defined(&SA110_CNTL_I2O_2048)) {
    sub SA110_CNTL_I2O_2048 () {	(3<< 10);}
}
unless(defined(&SA110_CNTL_I2O_4096)) {
    sub SA110_CNTL_I2O_4096 () {	(4<< 10);}
}
unless(defined(&SA110_CNTL_I2O_8192)) {
    sub SA110_CNTL_I2O_8192 () {	(5<< 10);}
}
unless(defined(&SA110_CNTL_I2O_16384)) {
    sub SA110_CNTL_I2O_16384 () {	(6<< 10);}
}
unless(defined(&SA110_CNTL_I2O_32768)) {
    sub SA110_CNTL_I2O_32768 () {	(7<< 10);}
}
unless(defined(&SA110_CNTL_WATCHDOG)) {
    sub SA110_CNTL_WATCHDOG () {	(1<< 13);}
}
unless(defined(&SA110_CNTL_ROMWIDTH_UNDEF)) {
    sub SA110_CNTL_ROMWIDTH_UNDEF () {	(0<< 14);}
}
unless(defined(&SA110_CNTL_ROMWIDTH_16)) {
    sub SA110_CNTL_ROMWIDTH_16 () {	(1<< 14);}
}
unless(defined(&SA110_CNTL_ROMWIDTH_32)) {
    sub SA110_CNTL_ROMWIDTH_32 () {	(2<< 14);}
}
unless(defined(&SA110_CNTL_ROMWIDTH_8)) {
    sub SA110_CNTL_ROMWIDTH_8 () {	(3<< 14);}
}
unless(defined(&SA110_CNTL_ROMACCESSTIME)) {
    sub SA110_CNTL_ROMACCESSTIME {
	local($x) = @_;
	eval q((($x)<<16));
    }
}
unless(defined(&SA110_CNTL_ROMBURSTTIME)) {
    sub SA110_CNTL_ROMBURSTTIME {
	local($x) = @_;
	eval q((($x)<<20));
    }
}
unless(defined(&SA110_CNTL_ROMTRISTATETIME)) {
    sub SA110_CNTL_ROMTRISTATETIME {
	local($x) = @_;
	eval q((($x)<<24));
    }
}
unless(defined(&SA110_CNTL_XCSDIR)) {
    sub SA110_CNTL_XCSDIR {
	local($x) = @_;
	eval q((($x)<<28));
    }
}
unless(defined(&SA110_CNTL_PCICFN)) {
    sub SA110_CNTL_PCICFN () {	(1<< 31);}
}
unless(defined(&CSR_PCIADDR_EXTN)) {
    sub CSR_PCIADDR_EXTN () {	 &DC21285_IO(0x0140);}
}
unless(defined(&CSR_PREFETCHMEMRANGE)) {
    sub CSR_PREFETCHMEMRANGE () {	 &DC21285_IO(0x0144);}
}
unless(defined(&CSR_XBUS_CYCLE)) {
    sub CSR_XBUS_CYCLE () {	 &DC21285_IO(0x0148);}
}
unless(defined(&CSR_XBUS_IOSTROBE)) {
    sub CSR_XBUS_IOSTROBE () {	 &DC21285_IO(0x014c);}
}
unless(defined(&CSR_DOORBELL_PCI)) {
    sub CSR_DOORBELL_PCI () {	 &DC21285_IO(0x0150);}
}
unless(defined(&CSR_DOORBELL_SA110)) {
    sub CSR_DOORBELL_SA110 () {	 &DC21285_IO(0x0154);}
}
unless(defined(&CSR_UARTDR)) {
    sub CSR_UARTDR () {	 &DC21285_IO(0x0160);}
}
unless(defined(&CSR_RXSTAT)) {
    sub CSR_RXSTAT () {	 &DC21285_IO(0x0164);}
}
unless(defined(&CSR_H_UBRLCR)) {
    sub CSR_H_UBRLCR () {	 &DC21285_IO(0x0168);}
}
unless(defined(&CSR_M_UBRLCR)) {
    sub CSR_M_UBRLCR () {	 &DC21285_IO(0x016c);}
}
unless(defined(&CSR_L_UBRLCR)) {
    sub CSR_L_UBRLCR () {	 &DC21285_IO(0x0170);}
}
unless(defined(&CSR_UARTCON)) {
    sub CSR_UARTCON () {	 &DC21285_IO(0x0174);}
}
unless(defined(&CSR_UARTFLG)) {
    sub CSR_UARTFLG () {	 &DC21285_IO(0x0178);}
}
unless(defined(&CSR_IRQ_STATUS)) {
    sub CSR_IRQ_STATUS () {	 &DC21285_IO(0x0180);}
}
unless(defined(&CSR_IRQ_RAWSTATUS)) {
    sub CSR_IRQ_RAWSTATUS () {	 &DC21285_IO(0x0184);}
}
unless(defined(&CSR_IRQ_ENABLE)) {
    sub CSR_IRQ_ENABLE () {	 &DC21285_IO(0x0188);}
}
unless(defined(&CSR_IRQ_DISABLE)) {
    sub CSR_IRQ_DISABLE () {	 &DC21285_IO(0x018c);}
}
unless(defined(&CSR_IRQ_SOFT)) {
    sub CSR_IRQ_SOFT () {	 &DC21285_IO(0x0190);}
}
unless(defined(&CSR_FIQ_STATUS)) {
    sub CSR_FIQ_STATUS () {	 &DC21285_IO(0x0280);}
}
unless(defined(&CSR_FIQ_RAWSTATUS)) {
    sub CSR_FIQ_RAWSTATUS () {	 &DC21285_IO(0x0284);}
}
unless(defined(&CSR_FIQ_ENABLE)) {
    sub CSR_FIQ_ENABLE () {	 &DC21285_IO(0x0288);}
}
unless(defined(&CSR_FIQ_DISABLE)) {
    sub CSR_FIQ_DISABLE () {	 &DC21285_IO(0x028c);}
}
unless(defined(&CSR_FIQ_SOFT)) {
    sub CSR_FIQ_SOFT () {	 &DC21285_IO(0x0290);}
}
unless(defined(&CSR_TIMER1_LOAD)) {
    sub CSR_TIMER1_LOAD () {	 &DC21285_IO(0x0300);}
}
unless(defined(&CSR_TIMER1_VALUE)) {
    sub CSR_TIMER1_VALUE () {	 &DC21285_IO(0x0304);}
}
unless(defined(&CSR_TIMER1_CNTL)) {
    sub CSR_TIMER1_CNTL () {	 &DC21285_IO(0x0308);}
}
unless(defined(&CSR_TIMER1_CLR)) {
    sub CSR_TIMER1_CLR () {	 &DC21285_IO(0x030c);}
}
unless(defined(&CSR_TIMER2_LOAD)) {
    sub CSR_TIMER2_LOAD () {	 &DC21285_IO(0x0320);}
}
unless(defined(&CSR_TIMER2_VALUE)) {
    sub CSR_TIMER2_VALUE () {	 &DC21285_IO(0x0324);}
}
unless(defined(&CSR_TIMER2_CNTL)) {
    sub CSR_TIMER2_CNTL () {	 &DC21285_IO(0x0328);}
}
unless(defined(&CSR_TIMER2_CLR)) {
    sub CSR_TIMER2_CLR () {	 &DC21285_IO(0x032c);}
}
unless(defined(&CSR_TIMER3_LOAD)) {
    sub CSR_TIMER3_LOAD () {	 &DC21285_IO(0x0340);}
}
unless(defined(&CSR_TIMER3_VALUE)) {
    sub CSR_TIMER3_VALUE () {	 &DC21285_IO(0x0344);}
}
unless(defined(&CSR_TIMER3_CNTL)) {
    sub CSR_TIMER3_CNTL () {	 &DC21285_IO(0x0348);}
}
unless(defined(&CSR_TIMER3_CLR)) {
    sub CSR_TIMER3_CLR () {	 &DC21285_IO(0x034c);}
}
unless(defined(&CSR_TIMER4_LOAD)) {
    sub CSR_TIMER4_LOAD () {	 &DC21285_IO(0x0360);}
}
unless(defined(&CSR_TIMER4_VALUE)) {
    sub CSR_TIMER4_VALUE () {	 &DC21285_IO(0x0364);}
}
unless(defined(&CSR_TIMER4_CNTL)) {
    sub CSR_TIMER4_CNTL () {	 &DC21285_IO(0x0368);}
}
unless(defined(&CSR_TIMER4_CLR)) {
    sub CSR_TIMER4_CLR () {	 &DC21285_IO(0x036c);}
}
unless(defined(&TIMER_CNTL_ENABLE)) {
    sub TIMER_CNTL_ENABLE () {	(1<< 7);}
}
unless(defined(&TIMER_CNTL_AUTORELOAD)) {
    sub TIMER_CNTL_AUTORELOAD () {	(1<< 6);}
}
unless(defined(&TIMER_CNTL_DIV1)) {
    sub TIMER_CNTL_DIV1 () {	(0);}
}
unless(defined(&TIMER_CNTL_DIV16)) {
    sub TIMER_CNTL_DIV16 () {	(1<< 2);}
}
unless(defined(&TIMER_CNTL_DIV256)) {
    sub TIMER_CNTL_DIV256 () {	(2<< 2);}
}
unless(defined(&TIMER_CNTL_CNTEXT)) {
    sub TIMER_CNTL_CNTEXT () {	(3<< 2);}
}
1;
