require '_h2ph_pre.ph';

unless(defined(&__ASM_ARM_IO_H)) {
    eval 'sub __ASM_ARM_IO_H () {1;}' unless defined(&__ASM_ARM_IO_H);
    if(defined(&__KERNEL__)) {
	require 'linux/types.ph';
	unless(defined(&NULL)) {
	    eval 'sub NULL () {( 0);}' unless defined(&NULL);
	}
    }
    require 'asm/hardware.ph';
    require 'asm/arch/memory.ph';
    require 'asm/arch/io.ph';
    require 'asm/proc/io.ph';
    eval 'sub virt_to_phys {
        local($x) = @_;
	    eval q(( &__virt_to_phys(($x))));
    }' unless defined(&virt_to_phys);
    eval 'sub phys_to_virt {
        local($x) = @_;
	    eval q((( &__phys_to_virt(($x)))));
    }' unless defined(&phys_to_virt);
    eval 'sub virt_to_bus {
        local($x) = @_;
	    eval q(( &__virt_to_bus(($x))));
    }' unless defined(&virt_to_bus);
    eval 'sub bus_to_virt {
        local($x) = @_;
	    eval q((( &__bus_to_virt(($x)))));
    }' unless defined(&bus_to_virt);
    eval 'sub __OUTS {
        local($s,$i,$x) = @_;
	    eval q( &extern  &void  &outs$s(\'unsigned int port\',  &const  &void * &from, \'int\'  &len););
    }' unless defined(&__OUTS);
    eval 'sub __INS {
        local($s,$i,$x) = @_;
	    eval q( &extern  &void  &ins$s(\'unsigned int port\',  &void * &to, \'int\'  &len););
    }' unless defined(&__INS);
    eval 'sub __IO {
        local($s,$i,$x) = @_;
	    eval q( &__OUTS($s,$i,$x)  &__INS($s,$i,$x));
    }' unless defined(&__IO);
    if(defined(&__outbc)) {
	eval 'sub outb {
	    local($val,$port) = @_;
    	    eval q(( &__builtin_constant_p(($port)) ?  &__outbc(($val),($port)) :  &__outb(($val),($port))));
	}' unless defined(&outb);
    } else {
	eval 'sub outb {
	    local($val,$port) = @_;
    	    eval q( &__outb(($val),($port)));
	}' unless defined(&outb);
    }
    if(defined(&__outwc)) {
	eval 'sub outw {
	    local($val,$port) = @_;
    	    eval q(( &__builtin_constant_p(($port)) ?  &__outwc(($val),($port)) :  &__outw(($val),($port))));
	}' unless defined(&outw);
    } else {
	eval 'sub outw {
	    local($val,$port) = @_;
    	    eval q( &__outw(($val),($port)));
	}' unless defined(&outw);
    }
    if(defined(&__outlc)) {
	eval 'sub outl {
	    local($val,$port) = @_;
    	    eval q(( &__builtin_constant_p(($port)) ?  &__outlc(($val),($port)) :  &__outl(($val),($port))));
	}' unless defined(&outl);
    } else {
	eval 'sub outl {
	    local($val,$port) = @_;
    	    eval q( &__outl(($val),($port)));
	}' unless defined(&outl);
    }
    if(defined(&__inbc)) {
	eval 'sub inb {
	    local($port) = @_;
    	    eval q(( &__builtin_constant_p(($port)) ?  &__inbc(($port)) :  &__inb(($port))));
	}' unless defined(&inb);
    } else {
	eval 'sub inb {
	    local($port) = @_;
    	    eval q( &__inb(($port)));
	}' unless defined(&inb);
    }
    if(defined(&__inwc)) {
	eval 'sub inw {
	    local($port) = @_;
    	    eval q(( &__builtin_constant_p(($port)) ?  &__inwc(($port)) :  &__inw(($port))));
	}' unless defined(&inw);
    } else {
	eval 'sub inw {
	    local($port) = @_;
    	    eval q( &__inw(($port)));
	}' unless defined(&inw);
    }
    if(defined(&__inlc)) {
	eval 'sub inl {
	    local($port) = @_;
    	    eval q(( &__builtin_constant_p(($port)) ?  &__inlc(($port)) :  &__inl(($port))));
	}' unless defined(&inl);
    } else {
	eval 'sub inl {
	    local($port) = @_;
    	    eval q( &__inl(($port)));
	}' unless defined(&inl);
    }
    eval 'sub ioaddr {
        local($port) = @_;
	    eval q(( &__builtin_constant_p(($port)) ?  &__ioaddrc(($port)) :  &__ioaddr(($port))));
    }' unless defined(&ioaddr);
    unless(defined(&ARCH_IO_DELAY)) {
	eval 'sub outb_p {
	    local($val,$port) = @_;
    	    eval q( &outb(($val),($port)));
	}' unless defined(&outb_p);
	eval 'sub outw_p {
	    local($val,$port) = @_;
    	    eval q( &outw(($val),($port)));
	}' unless defined(&outw_p);
	eval 'sub outl_p {
	    local($val,$port) = @_;
    	    eval q( &outl(($val),($port)));
	}' unless defined(&outl_p);
	eval 'sub inb_p {
	    local($port) = @_;
    	    eval q( &inb(($port)));
	}' unless defined(&inb_p);
	eval 'sub inw_p {
	    local($port) = @_;
    	    eval q( &inw(($port)));
	}' unless defined(&inw_p);
	eval 'sub inl_p {
	    local($port) = @_;
    	    eval q( &inl(($port)));
	}' unless defined(&inl_p);
	eval 'sub outsb_p {
	    local($port,$from,$len) = @_;
    	    eval q( &outsb($port,$from,$len));
	}' unless defined(&outsb_p);
	eval 'sub outsw_p {
	    local($port,$from,$len) = @_;
    	    eval q( &outsw($port,$from,$len));
	}' unless defined(&outsw_p);
	eval 'sub outsl_p {
	    local($port,$from,$len) = @_;
    	    eval q( &outsl($port,$from,$len));
	}' unless defined(&outsl_p);
	eval 'sub insb_p {
	    local($port,$to,$len) = @_;
    	    eval q( &insb($port,$to,$len));
	}' unless defined(&insb_p);
	eval 'sub insw_p {
	    local($port,$to,$len) = @_;
    	    eval q( &insw($port,$to,$len));
	}' unless defined(&insw_p);
	eval 'sub insl_p {
	    local($port,$to,$len) = @_;
    	    eval q( &insl($port,$to,$len));
	}' unless defined(&insl_p);
    } else {
	if(defined(&__outbc_p)) {
	    eval 'sub outb_p {
	        local($val,$port) = @_;
    		eval q(( &__builtin_constant_p(($port)) ?  &__outbc_p(($val),($port)) :  &__outb_p(($val),($port))));
	    }' unless defined(&outb_p);
	} else {
	    eval 'sub outb_p {
	        local($val,$port) = @_;
    		eval q( &__outb_p(($val),($port)));
	    }' unless defined(&outb_p);
	}
	if(defined(&__outwc_p)) {
	    eval 'sub outw_p {
	        local($val,$port) = @_;
    		eval q(( &__builtin_constant_p(($port)) ?  &__outwc_p(($val),($port)) :  &__outw_p(($val),($port))));
	    }' unless defined(&outw_p);
	} else {
	    eval 'sub outw_p {
	        local($val,$port) = @_;
    		eval q( &__outw_p(($val),($port)));
	    }' unless defined(&outw_p);
	}
	if(defined(&__outlc_p)) {
	    eval 'sub outl_p {
	        local($val,$port) = @_;
    		eval q(( &__builtin_constant_p(($port)) ?  &__outlc_p(($val),($port)) :  &__outl_p(($val),($port))));
	    }' unless defined(&outl_p);
	} else {
	    eval 'sub outl_p {
	        local($val,$port) = @_;
    		eval q( &__outl_p(($val),($port)));
	    }' unless defined(&outl_p);
	}
	if(defined(&__inbc_p)) {
	    eval 'sub inb_p {
	        local($port) = @_;
    		eval q(( &__builtin_constant_p(($port)) ?  &__inbc_p(($port)) :  &__inb_p(($port))));
	    }' unless defined(&inb_p);
	} else {
	    eval 'sub inb_p {
	        local($port) = @_;
    		eval q( &__inb_p(($port)));
	    }' unless defined(&inb_p);
	}
	if(defined(&__inwc_p)) {
	    eval 'sub inw_p {
	        local($port) = @_;
    		eval q(( &__builtin_constant_p(($port)) ?  &__inwc_p(($port)) :  &__inw_p(($port))));
	    }' unless defined(&inw_p);
	} else {
	    eval 'sub inw_p {
	        local($port) = @_;
    		eval q( &__inw_p(($port)));
	    }' unless defined(&inw_p);
	}
	if(defined(&__inlc_p)) {
	    eval 'sub inl_p {
	        local($port) = @_;
    		eval q(( &__builtin_constant_p(($port)) ?  &__inlc_p(($port)) :  &__inl_p(($port))));
	    }' unless defined(&inl_p);
	} else {
	    eval 'sub inl_p {
	        local($port) = @_;
    		eval q( &__inl_p(($port)));
	    }' unless defined(&inl_p);
	}
    }
    require 'linux/kernel.ph';
    unless(defined(&readb)) {
	eval 'sub readb {
	    local($p) = @_;
    	    eval q(( &panic(\\"readb called, but not implemented\\"),0));
	}' unless defined(&readb);
    }
    unless(defined(&readw)) {
	eval 'sub readw {
	    local($p) = @_;
    	    eval q(( &panic(\\"readw called, but not implemented\\"),0));
	}' unless defined(&readw);
    }
    unless(defined(&readl)) {
	eval 'sub readl {
	    local($p) = @_;
    	    eval q(( &panic(\\"readl called, but not implemented\\"),0));
	}' unless defined(&readl);
    }
    unless(defined(&writeb)) {
	eval 'sub writeb {
	    local($v,$p) = @_;
    	    eval q( &panic(\\"writeb called, but not implemented\\"));
	}' unless defined(&writeb);
    }
    unless(defined(&writew)) {
	eval 'sub writew {
	    local($v,$p) = @_;
    	    eval q( &panic(\\"writew called, but not implemented\\"));
	}' unless defined(&writew);
    }
    unless(defined(&writel)) {
	eval 'sub writel {
	    local($v,$p) = @_;
    	    eval q( &panic(\\"writel called, but not implemented\\"));
	}' unless defined(&writel);
    }
    unless(defined(&memcpy_fromio)) {
	eval 'sub memcpy_fromio {
	    local($to,$from,$len) = @_;
    	    eval q( &_memcpy_fromio(,($from),($len)));
	}' unless defined(&memcpy_fromio);
    }
    unless(defined(&memcpy_toio)) {
	eval 'sub memcpy_toio {
	    local($to,$from,$len) = @_;
    	    eval q( &_memcpy_toio(($to),($from),($len)));
	}' unless defined(&memcpy_toio);
    }
    unless(defined(&memset_io)) {
	eval 'sub memset_io {
	    local($addr,$c,$len) = @_;
    	    eval q( &_memset_io(($addr),($c),($len)));
	}' unless defined(&memset_io);
    }
    undef(&ARCH_READWRITE) if defined(&ARCH_READWRITE);
    undef(&ARCH_IO_DELAY) if defined(&ARCH_IO_DELAY);
    undef(&ARCH_IO_CONSTANT) if defined(&ARCH_IO_CONSTANT);
}
1;
